import { IModel, IModelUniform, ITexture2D } from '@antv/l7-core';
import BaseModel from '../../core/BaseModel';
export default class WindModel extends BaseModel {
    protected texture: ITexture2D;
    private colorModel;
    private wind;
    private imageCoords;
    private sizeScale;
    private frequency;
    render(): void;
    getUninforms(): IModelUniform;
    initModels(): IModel[];
    getWindSize(): {
        imageWidth: number;
        imageHeight: number;
    };
    buildModels(): IModel[];
    clearModels(): void;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected registerBuiltinAttributes(): void;
    private drawWind;
    private drawColorMode;
}
